
#ifndef _AI_SWARM_H
#define _AI_SWARM_H

#include "world_entity.h"
#include "ai_module.h"

class AISwarm{
	public:
		AISwarm();
		~AISwarm(){}
		void process(float dt);
		void addAI(AIModule* newMember);
		void removeAI(AIModule* oldMember);
		inline int getSwarmSize(){return swarmMembers.size();}
		inline void setEnemyList(std::vector<WorldEntity*>* enemyList){this->enemyList=enemyList;}
		inline void setDestination(Vector destination){this->destination=destination;}
		Vector getPosition();
	private:
		Vector destination;
		Vector movement;
		std::vector<WorldEntity*>* enemyList;
		std::set<AIModule*> swarmMembers;
		int tickCount;
		int randomFreq;
		Vector randomVector;
};

#endif /* _AI_SWARM_H */
